//--------------------------------------------------------------------------------------------------
//      _    _    ______
//     | |  / /   | |___ \.
//     | |_/ /    | |___| |
//     | | \ \    | |___ /
//     | |  \ \   | |
//     |_|   \_\  |_|
//
//--------------------------------------------------------------------------------------------------
/*
 Beschreibung:

 Open Source Licensing
 Dieses Programm ist Freie Software: Sie können es unter den Bedingungen
 der GNU General Public License, wie von der Free Software Foundation,
 Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren
 veröffentlichten Version, weiterverbreiten und/oder modifizieren.

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

 Anregung Fachbuecher Rheinwerk Verlag
 Einstieg in C
 Thomas Theis
 ehem. Galileo Computing

 Author:      Kurt Pieper
 History:     28.06.2014
 Update:      05.07.2017
 SQlite3 Anwendung
 Elektronische Bauteile verwalten
 Uebungsprogramm
*/
//-------------------------------------------------------------------------------------------------
// Einrichtung
// z.B Pfad anlegen
// user ist der Benutzer des Systems
// zB bei Raspbery ist user pi
// mkdir /home/user/ec-lager
// cd /home/user/ec-lager
// Programm create.c nach /home/user/ec-lager kopieren
// Downloads
// sudo apt-get update
// sudo apt-get install sqlite3 libsqlite3-dev
// apt-get install sqlitebrowser
// sqlite3.o sqlite3.c sqlite3.h nach /home/user/ec-lager kopieren
//
// wir befinden uns: /home/user/ec-lager
// Programm: Datenbankdatei anlegen
// gcc -o create create.c -lsqlite3
// sudo ./create
// Alternativ lese info.txt mit create.first
// Datei: leer.db kann kopiert werden z.B. bauteile.db
// Aufruf aus einem C-Programm
// system ("sqlitebrowser /home/user/ec-lager/bauteile.db");
// Jetzt können die Daten der sqlite3 Datei bearbeitet werden.
// sqlitebrowser /home/user/ec-lager/bauteile.db
//
// Das Programm nach eigenen Vorstellung verändert werden.
// Die Datennankfelder werden im Prg sqlitebrowser angezeigt.
//
//
#include <stdio.h>
#include <string.h>
#include "sqlite3.h"

int main()
{
   sqlite3 *db;
   char sql[255];
   char *meldung;

   if(sqlite3_open("leer.db", &db))
   { printf("Fehler bei Verbindung\n"); return 1; }

   strcpy(sql, "CREATE TABLE IF NOT EXISTS lager("
 	"Wert PRIMARY KEY, "
	"Menge INTEGER, "
 	"Type TEXT, "
 	"Solder TEXT, "
 	"CaseForm TEXT, "
	"Lagerung TEXT, "
	"Kommentar TEXT)");

   if(sqlite3_exec(db, sql, NULL, NULL, &meldung))
   { printf("Fehler: %s\n", meldung); return 1; }
	printf("Datei leer.db angelegt. Kann mit cp leer.db bauteile.db kopiert werden\n");
  sqlite3_close(db);
   return 0;
}

