//--------------------------------------------------------------------------------------------------
//      _    _    ______
//     | |  / /   | |___ \.
//     | |_/ /    | |___| |
//     | | \ \    | |___ /
//     | |  \ \   | |
//     |_|   \_\  |_|
//
//--------------------------------------------------------------------------------------------------
/*
 Beschreibung:

 Open Source Licensing
 Dieses Programm ist Freie Software: Sie können es unter den Bedingungen
 der GNU General Public License, wie von der Free Software Foundation,
 Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren
 veröffentlichten Version, weiterverbreiten und/oder modifizieren.

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

 Anregung Fachbuecher
 Grundcurs C - Juergen Wolf
 Einstieg in C - Thomas Theis
 ehem. Galileo Computing
 Rheinwerk Computing

 Author:      Kurt Pieper
 Ersteinstieg 2014
 History:     28.06.2017
 Update:      04.07.2017
 SQlite3 Anwendung Elektronische Bauteile verwalten
 Uebungsprogramm 1


*/
//-------------------------------------------------------------------------------------------------

/*
Funktionsrückmeldungen
Konstanten 		Fehlercodes 	Bedeutung
SQLITE_OK 		0 	Erfolgreich ausgeführt
SQLITE_ERROR 		1 	SQL Fehler oder fehlende Datenbank
SQLITE_INTERNAL 	2 	interner SQLite Fehler
SQLITE_PERM 		3 	Zugriff verweigert
SQLITE_ABORT 		4 	Callback-Funktion fordert Abbruch
SQLITE_BUSY 		5 	Datenbankdatei gesperrt
SQLITE_LOCKED 		6 	Tabelle in Datenbank gesperrt
SQLITE_NOMEM 		7 	Konnte keinen Speicher reservieren
SQLITE_READONLY 	8 	Dankbank im Nur-Lesen-Modus
SQLITE_INTERRUPT 	9 	Operation von sqlite3_interrupt() abgebrochen
SQLITE_IOERR 		10 	I/O Fehler auf Speichermedium
SQLITE_CORRUPT 		11 	Fehlerhaftes Datenbank-Image
SQLITE_NOTFOUND 	12 	NICHT BENUTZT Tabelle oder Record nicht gefunden
SQLITE_FULL 		13 	Einfügen fehlgeschlagen: Datenbank voll
SQLITE_CANTOPEN 	14 	Datenbank kann nicht geöffnet werden
SQLITE_PROTOCOL 	15 	NICHT BENUTZT Datenbank gesperrt:Protokollfehler
SQLITE_EMPTY 		16 	Datenbank leer
SQLITE_SCHEMA 		17 	Datenbankschema geändert
SQLITE_TOOBIG 		18 	String oder BLOB zu groß
SQLITE_dbSTRAINT 	19 	Abbruch wegen dbstraint Verletzung
SQLITE_MISMATCH 	20 	Nicht zusammenpassende Datentypen
SQLITE_MISUSE 		21 	Inkorrekter Gebrauch der Library
SQLITE_NOLFS 		22 	Die Benutzen Features werden vom Host nicht unterstützt
SQLITE_AUTH 		23 	Autorisierung verweigert.
SQLITE_FORMAT 		24 	Hilfsdatenbank Format Fehler
SQLITE_RANGE 		25 	zweiter Parameter von sqlite3_bind außer Reichweite
SQLITE_NOTADB 		26 	Datei ist keine Datenbank
SQLITE_ROW 		100 	sqlite_step() hat weitere Zeile bereit
SQLITE_DONE 		101 	sqlite_step() abgeschlossen
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sqlite3.h"
#define LINEBUF 256
// user zB pi bei Raspberry
#define DATABASE "/home/user/ec-lager/bauteile.db"		// sqlite3 Datei
#define MAX 50
#define ZAHL 1
#define Version " Demo Prog"

// sqlite3 *db;

//int Anzahl=1;  // Anzahl der Datensaetze siehe Funktion Ausgabe

//int last_id;
int GLOBALE_A ;
int GLOBALE_B ;

// Datensaetze sqlite3
//char id_db[5];
int id_db;
char Wert_db[15];
char Menge_db[5];
char Type_db[20];
char Solder_db[5];
char Fall_db[10];
char Lagerung_db[20];
char Kommentar_db[40];

// Datensaetze Erfassung
typedef struct sq3_tag {
int id;
char id_ch[5];
char Wert[15];
char Menge[5];
char Type[20];
char Solder[5];
char Fall[10];
char Lagerung[20];
char Kommentar[40];
} sq3_t;

// Programm case 1b
// Datensaetze Bildschirmausgabe
void output(sq3_t *lager) {
	int id;
	id = GLOBALE_B;
	id++;
	printf("\n");
	printf("ID                  :  %i\n", lager->id);
	printf("Wert                :  %s\n", lager->Wert);
	printf("Menge               :  %s\n", lager->Menge);
	printf("Type                :  %s\n", lager->Type);
	printf("Solder              :  %s\n", lager->Solder);
	printf("Fall                :  %s\n", lager->Fall);
	printf("Lagerung            :  %s\n", lager->Lagerung);
	printf("Kommentar           :  %s\n", lager->Kommentar);
}

// hier wird CR entfernt und 0 eingefuegt
// sqlite File bauteile.db - jedes Feld ohne Cariage Return
void nl2space( char str[] ) {
	int i, n = strlen(str);
	for( i = 0; i < n; i++) {
		if( str[i] == '\n' ) {
		str[i] = '\0';
		}
	}
}

// Programmteil Ausgabe aus Funktion
int check_lastid(void *info,int anzahlFelder, char **feldWert, char **feldName)
{
	int i;
	for (i=0; i<anzahlFelder; i++)
        printf("Id   = %s\n", feldWert[0]);
                GLOBALE_A = atoi(feldWert[0]);
	//printf("Lastid %i", last_id);
        return GLOBALE_A;
}



// id holen fuer Neuanlage Datensatz
int check_id(void *info, int anzahlFelder, char **feldWert, char **feldName)
     {
        int i, last_id;
        for (i=0; i<anzahlFelder; i++)
          nl2space( feldWert[0] );
          last_id = atoi(feldWert[0]);
          GLOBALE_A = last_id;
          printf("\nAnzahl der Datensaetze = %s \n", feldWert[0]);

          return GLOBALE_A;
}

// Prog Case 6
int id_read(void) {

       sqlite3 *db;
        char *err_msg = 0;

       int rc = sqlite3_open(DATABASE, &db);

        if (rc != SQLITE_OK) {
         sqlite3_close(db);
         return 0;
       }

        char *sql = "SELECT count(0) FROM lager";
//        char *sql = "SELECT _ROWID_ FROM lager";
//	char *sql = "SELECT * FROM lager last_insert_rowid";

//        rc = sqlite3_exec(db, sql, &check_lastid, 0, &err_msg);
        rc = sqlite3_exec(db, sql, &check_id, 0, &err_msg);
	//printf("last_id GLOBALE_A %i", GLOBALE_A);
        if (rc != SQLITE_OK ) {
        sqlite3_close(db);
       return 0;
       }

    return 0;
}


// Pgr Case 4
void sq3inputid() {
        sqlite3 *db;
        char sql[255];
        char *meldung;
	//char str[255];
        sq3_t data[ZAHL];
        int i;
        int z;

        if(sqlite3_open(DATABASE, &db))
        { printf("Fehler bei Verbindung\n"); return ; }


        for( i=0; i < ZAHL; i++) {
                printf("id. Nr    : \n");

	        printf("id         :  ");
                fgets(data[i].id_ch, 5, stdin);
                nl2space( data[i].id_ch );
		id_db = atoi(data[i].id_ch);

                printf("Wert       :  ");
                fgets(data[i].Wert, 20, stdin);
                nl2space( data[i].Wert );

                printf("Menge       :  ");
                fgets(data[i].Menge, 10, stdin);
                nl2space( data[i].Menge );

                printf("Type        :  ");
                fgets(data[i].Type, 30, stdin);
                nl2space( data[i].Type );

                printf("Solder      :  ");
                fgets(data[i].Solder, 10, stdin);
                nl2space( data[i].Solder );

                printf("Case        :  ");
                fgets(data[i].Fall, 20, stdin);
                nl2space( data[i].Fall );

                printf("Lagerung    :  ");
                fgets(data[i].Lagerung, 30, stdin);
                nl2space( data[i].Lagerung );

                printf("Kommentar   :  ");
                fgets(data[i].Kommentar, 40, stdin);
                nl2space( data[i].Kommentar );
        }


        printf("Satz speichern %i\n ", id_db);
        printf("1 = OK Daten speichern 2 = Abbruch : ");
        scanf("%i", &z);

        if (z == 1) {
                //strcpy(id_db ,data[0].id);
                strcpy(Wert_db ,data[0].Wert);
                strcpy(Menge_db ,data[0].Menge);
                strcpy(Type_db, data[0].Type);
                strcpy(Solder_db, data[0].Solder);
                strcpy(Fall_db, data[0].Fall);
                strcpy(Lagerung_db, data[0].Lagerung);
                strcpy(Kommentar_db, data[0].Kommentar);
//              sqlite3 Datensatz
                sprintf(sql ,"INSERT INTO lager VALUES ('%i', '%s', '%s', '%s', '%s', '%s','%s','%s');", id_db, Wert_db, Menge_db, Type_db, Solder_db, Fall_db, Lagerung_db, Kommentar_db);

                if(sqlite3_exec(db, sql, NULL, NULL, &meldung))
                { printf("Fehler: %s\n", meldung); return ; }

        }       // nach if z

       if ( z == 2 ) {
                printf("keine Speicherung?\n");
        }

        sqlite3_close(db);
        return;
}


// Programm case 1
void sq3input() {
	sqlite3 *db;
	char sql[255];
	char *meldung;
	sq3_t data[ZAHL];
	int i;
	int z;

	if(sqlite3_open(DATABASE, &db))
	{ printf("Fehler bei Verbindung\n"); return ; }

	for( i=0; i < ZAHL; i++) {
		printf("id. Nr    : \n");

		// id einlesen GLOBALE_A
		id_read();

		id_db = GLOBALE_A;  // letzter Datensatz
		id_db++;            // neuer Datebsatz
		GLOBALE_A = id_db;
		printf("GLOBALE_A   id_db+1  GLOBALE_B   :%i %i %i \n",GLOBALE_A, id_db, GLOBALE_B);

		//strcpy(data[i].id, id_db);

		printf("Wert        :  ");
		fgets(data[i].Wert,20,stdin);
		nl2space( data[i].Wert );

		printf("Menge       :  ");
		fgets(data[i].Menge, 10, stdin);
		nl2space( data[i].Menge );

		printf("Type        :  ");
		fgets(data[i].Type, 30, stdin);
		nl2space( data[i].Type );

		printf("Solder      :  ");
		fgets(data[i].Solder, 10, stdin);
		nl2space( data[i].Solder );

		printf("Case        :  ");
		fgets(data[i].Fall, 20, stdin);
		nl2space( data[i].Fall );

		printf("Lagerung    :  ");
		fgets(data[i].Lagerung, 30, stdin);
		nl2space( data[i].Lagerung );

		printf("Kommentar   :  ");
		fgets(data[i].Kommentar, 40, stdin);
		nl2space( data[i].Kommentar );
	}

//	for (i=0; i < ZAHL; i++) {
//         output(&data[i]);
//   }

	printf("Satz speichern %i\n ", id_db);
	printf("1 = OK Daten speichern 2 = Abbruch : ");
	scanf("%i", &z);

	if (z == 1) {
		//strcpy(id_db ,data[0].id);
		strcpy(Wert_db ,data[0].Wert);
		strcpy(Menge_db ,data[0].Menge);
		strcpy(Type_db, data[0].Type);
		strcpy(Solder_db, data[0].Solder);
		strcpy(Fall_db, data[0].Fall);
		strcpy(Lagerung_db, data[0].Lagerung);
		strcpy(Kommentar_db, data[0].Kommentar);
//              sqlite3 Datensatz
         	sprintf(sql ,"INSERT INTO lager VALUES ('%i', '%s', '%s', '%s', '%s', '%s','%s','%s');", id_db, Wert_db, Menge_db, Type_db, Solder_db, Fall_db, Lagerung_db, Kommentar_db);

		if(sqlite3_exec(db, sql, NULL, NULL, &meldung))
		{ printf("Fehler: %s\n", meldung); return ; }

	}       // nach if z

	if ( z == 2 ) {
		printf("keine Speicherung?\n");
	}

	sqlite3_close(db);
	return;
}

int ausgabeMini(void *info,int anzahlFelder,
	char **feldWert, char **feldBezeichnung)
{
//  - vor Ziffer setzt Ausgabe linkbuendig
	printf("Wert  :%-15s  Type    :%s \n", feldWert[1], feldWert[3]);
	return 0;
}

int ausgabeTele(void *info,int anzahlFelder,
	char **feldWert, char **feldBezeichnung)
{
//  - vor Ziffer setzt Ausgabe linkbuendig
	printf("Id %-5s Wert :%-15s %-5s %-20s %-6s %-10s %-20s %s\n", feldWert[0],
		feldWert[1], feldWert[2], feldWert[3], feldWert[4], feldWert[5], feldWert[6], feldWert[7]);
   return 0;
}

int ausgabeTest(void *info,int anzahlFelder,
	char **feldWert, char **feldBezeichnung)
{
//  - vor Ziffer setzt Ausgabe linkbuendig
	printf("%s, %-5s  %-5s  %-10s\b, %-25s  %-10s %-10s  %s\n", feldWert[0],
		feldWert[1], feldWert[2], feldWert[3], feldWert[4], feldWert[5], feldWert[6], feldWert[7]);
	return 0;
}

// Programmteil Ausgabe aus Funktion
int ausgabeBlock(void *info,int anzahlFelder,
	char **feldWert, char **feldBezeichnung)
{
	printf("Id   = %s\nWert     :%s\nMenge    :%s\nType     :%s\nSolder   :%s\nFall     :%s\nLagerung :%s\nKommentar:%s\n", feldWert[0], feldWert[1],
		feldWert[2], feldWert[3], feldWert[4], feldWert[5], feldWert[6], feldWert[7]);
		 GLOBALE_B = atoi(feldWert[0]);
	return 0;
}


// Programm case 7 Teil b
// Anzeige neu Funktion sq3liste()
// Fertig 23.06.2014
int ausgabe(void *info,int anzahlFelder,
   char **feldWert, char **feldBezeichnung)
{
   printf("%s  %s  %s %s  %s \n", feldWert[0],
      feldWert[1], feldWert[2], feldWert[3], feldWert[4]);
   return 0;
}

// Programm case 7 Teil a
// Anzeige der sqlite Datensaetze
// Fertig 29.05.2014
int sq3liste(int arg)
{
	sqlite3 *db;
	char sql[255], *meldung;
	char info[20] = "SQlite3 Nr: ";
	//Anzahl=1;

	if(sqlite3_open(DATABASE, &db))
	{ printf("Fehler bei Verbindung\n"); return 1; }
	strcpy(sql, "SELECT * FROM lager");

//      Auswahl der Listen Arg 1-4
   	if (arg == 4) {
        	if(sqlite3_exec(db, sql, ausgabeTest, info, &meldung))
        	{ printf("Fehler Datei nicht gefunden: %s\n", meldung); return 1; }
   	}
   	else if (arg == 3) {
        	if(sqlite3_exec(db, sql, ausgabeTele, info, &meldung))
        	{ printf("Fehler Datei nicht gefunden: %s\n", meldung); return 1; }
   	}
   	else if (arg == 2) {
        	if(sqlite3_exec(db, sql, ausgabeBlock, info, &meldung))
        	{ printf("Fehler Datei nicht gefunden: %s\n", meldung); return 1; }
   	}
   	else if (arg == 1) {
        	if(sqlite3_exec(db, sql, ausgabeMini, info, &meldung))
        	{ printf("Fehler Datei nicht gefunden: %s\n", meldung); return 1; }
   	}
   	else {
		printf("Auswahl ungleich 1,2,3 oder 4\n");    // hier kommen wir nicht hin
   }
   sqlite3_close(db);
   return 0;
}


// Musterdatensatz anlegen
int sq3insert()
{
	sqlite3 *db;
	char sql[255];
	char *meldung;
	if(sqlite3_open(DATABASE, &db))
	{ printf("Fehler bei Verbindung\n"); return 1; }

	id_db = 99999;
	strcpy(Wert_db ,"Test 99999");
	strcpy(Menge_db ,"100");
	strcpy(Type_db, "Drehgeber");
	strcpy(Solder_db, "PIN8");
	strcpy(Fall_db,"22");
	strcpy(Lagerung_db,"Box");
	strcpy(Kommentar_db,"Analoge Signal messen mit id");

	// muessen 8 Felder sein !!!!!!
	 sprintf(sql ,"INSERT INTO lager VALUES ('%i', '%s', '%s', '%s', '%s', '%s','%s','%s');", id_db, Wert_db, Menge_db, Type_db, Solder_db, Fall_db, Lagerung_db, Kommentar_db);

	if(sqlite3_exec(db, sql, NULL, NULL, &meldung))
	{ printf("Satz vorhanden - Fehler: %s\n", meldung); return 1; }

	sqlite3_close(db);
	return 0;
}


// Musterdatensatz löschen
int sq3delete()
{
        sqlite3 *db;
        char sql[255], *meldung;

        if(sqlite3_open(DATABASE, &db))

        { printf("Fehler bei Verbindung\n"); return 1; }

        strcpy(sql, "DELETE FROM lager "
        "WHERE Wert = 'Test 99999'");

        if(sqlite3_exec(db, sql, NULL, NULL, &meldung))
        { printf("Fehler: %s\n", meldung); return 1; }
        printf("Betroffen: %d\n", sqlite3_changes(db));

        strcpy(sql, "SELECT * FROM lager");
        if(sqlite3_exec(db, sql, ausgabe, NULL, &meldung))
        { printf("Fehler: %s\n", meldung); return 1; }
        printf("\n");

        sqlite3_close(db);
        return 0;
}

// Eingabe Pgr 3 Datensatz loeschen
int sq3loeschen()
{
        sqlite3 *db;
        char sql[255];
        char *meldung;
        sq3_t data[ZAHL];

        if(sqlite3_open(DATABASE, &db))
        { printf("\nFehler bei Verbindung\n"); return 1; }

        printf("\nWert Suchname       :  ");
        fgets(data[0].Wert, 15, stdin);
        nl2space( data[0].Wert );
        strcpy(Wert_db, data[0].Wert);

//      OK geht so !!!
//      Eingabe in der Datenbak suchen
        sprintf(sql, "SELECT * FROM lager WHERE Wert LIKE '%s'", Wert_db);

        if(sqlite3_exec(db, sql, ausgabeBlock, NULL, &meldung))
        { printf("Fehler: %s\n", meldung); return 1; }
        printf("\n");

//      Uebergabe id aus Datenbank siehe sqliteBlock
	id_db = GLOBALE_B;

	printf("id_db = GLOBALE_B %i\n",id_db);

        printf("Wurde gelöscht! %i, %s\n", id_db, Wert_db );
       	sprintf(sql ,"DELETE FROM lager WHERE id = ('%i');", id_db);

        if(sqlite3_exec(db, sql, NULL, NULL, &meldung))
        { printf("Fehler: %s\n", meldung); return 1; }
        printf("Betroffen: %d\n", sqlite3_changes(db));
        sqlite3_close(db);

        return 1;
}

//
int sq3suchen()
{
	sqlite3 *db;
	char sql[255];
	char *meldung;
    	sq3_t data[ZAHL];

	if(sqlite3_open(DATABASE, &db))
    	{ printf("\nFehler bei Verbindung\n"); return 1; }

   	printf("\nWert Suchname       :  ");
    	fgets(data[0].Wert, 15, stdin);
	nl2space( data[0].Wert );
	strcpy(Wert_db, data[0].Wert);

//      OK geht so !!!
	sprintf(sql, "SELECT * FROM lager WHERE Wert LIKE '%s'", Wert_db);

	if(sqlite3_exec(db, sql, ausgabeBlock, NULL, &meldung))
	{ printf("Fehler: %s\n", meldung); return 1; }
	printf("\n");

/*

	printf("Weiter mit ENTER ");
	char str[255];
        unsigned char s = 0;
	scanf("%254[0-9]", str);
	if (s < 0 ) {
		printf("Fehler ");
	}
*/
	return 1;
}

// Bildschirmausgabe
//void menu (fileBezeichnung1){
void menu(){
	system ("clear");
	printf("------------------------------\n");
	printf("| Sqlite3       : %s |\n",Version);
	printf("| [" __DATE__ " " __TIME__"]     |\n");
	printf("------------------------------\n");
	printf("-1- Eingabe \n");
	printf("-2- Suchen Wert\n");
	printf("-3- Loeschen Datensatz\n");
	printf("-4- Eingabe id direkt\n");
	printf("-5- Sqlite Browser\n");
	printf("-6- Anzahl Datensaetze \n");
	printf("-7- Bildschirmausgabe\n");
	printf("-8- Datensatz 99999 anlegen\n");
	printf("-9- Datensatz 99999 löschen\n");
	printf("-0- Beenden \n");
	printf("Ihre Auswahl: ");
}


// H a u p t p r o g r a g r a m m //

int main(void) {

	unsigned char s = 0;
	int j,z;
	int input;

	menu();

	while (1) {
		do { scanf("%i", &input); } while(getchar() != '\n');
		switch( input ) {
		case 1 :   if (j <= 0) {
		        //sq3liste(1);  keine Liste
		        }
	           	j = 0;
	           	sq3input();
                        //Abfrage ENTER nach Neuanlage
                                char chrein;
                                char bufein[2];
                                fgets(bufein, 2, stdin);
                                sscanf(bufein, "%c", &chrein);
                         //       break;

	           	goto Label;
			break;
		case 2 :   sq3suchen();
			//goto Label;
			break;
		case 3 :  //Loeschung Datensatz
			   sq3loeschen();
			break;
		case 4 :   sq3inputid();
			goto Label;
			break;
		case 5 : system ("sqlitebrowser /home/user/ec-lager/bauteile.db");
			break;
		case 6 :  id_read();
			break;
		case 7 :
			printf("Welches Format Datei\n");
			printf("1 = Kurzliste 2 = Block 3 = Liste 4 = Komplett Ausgabe: ");
			scanf("%d", &z);
			if ( (z > 0) && (z >=5) ) {
				printf("-----------------------\n");
				printf("Bitte waehle\n");
				printf("1, 2, 3 oder 4 \n");
				printf("---------------\n");
					}
			else {
					system ("clear");  // OK 1-4
					}
			if (z == 1 ) {
				printf("OK Kurzliste\n");
				sq3liste(1);
				printf("\nDatei: bauteile.db - Dateiende!\n");
					}
			else if (z == 2 ) {
				printf("OK Block) \n" );
				sq3liste(2);
				printf("\nDatei: bauteile.db - Dateiende!\n");
					}
			else if (z == 3 ) {
				printf("Liste 3                      Menge   Type               Solder   Fall       Lagerung             Kommentar \n");
				printf("--------------------------------------------------------------------------------------------------------------\n");
				sq3liste(3);
				printf("\nDatei: bauteile.db - Dateiende!\n");
					}
			else if (z == 4 ) {
				printf("OK 3 statt 4 Gesamt) \n");
				sq3liste(3);
				printf("\nDatei: bauteile.db - Dateiende!\n");
					}
			else {
				printf("\nEingabe %i ? geht nicht.\n", z);
				z = 0;
					}
//              Abfrage ENTER nach Anzeige bauteile.db
				char ch;
				char buf[2];
				fgets(buf, 2, stdin);
				sscanf(buf, "%c", &ch);
				break;
		case 8 :   printf("Datensatz anlegen\n");
               			sq3insert();
               		   break;
		case 9 :   printf("Datensatz löschen ");
               			sq3delete();
               		   break;
		case 10:
			   break;
		case 0 :
		default:
			   printf("Bye~~\n");
			   return 0;
		}

	printf("Weiter mit ENTER!");
	char str[255];
	scanf("%254[0-9]", str);
	if (s < 0 ) {
		printf("Fehler ");
	}
Label:	           // goto Label möglich
	menu();
}
	return EXIT_SUCCESS;
}


